package com.picfun.freqanalizer;

import android.app.Activity;
import android.os.Bundle;
import android.content.Context;
import android.content.Intent;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.hardware.usb.UsbConstants;
import android.hardware.usb.UsbDevice;
import android.hardware.usb.UsbDeviceConnection;
import android.hardware.usb.UsbEndpoint;
import android.hardware.usb.UsbInterface;
import android.hardware.usb.UsbManager;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.view.Gravity;
import android.os.Handler;
import android.widget.EditText;
import android.text.SpannableStringBuilder;
import android.view.WindowManager;

public class FreqAnalizerHost extends Activity implements Runnable {
	/***********************************************************************/
	// USB関連変数定義
	private UsbManager mUsbManager;    
	private UsbDevice mDevice;    
	private UsbDeviceConnection mConnection;    
	private UsbEndpoint mEndpointOut;
	private UsbEndpoint mEndpointIn;
	// バッファ、一般変数定義
	private byte[] message = new byte[64]; 	
	private byte[] buffer = new byte[64];
	private int[] DataBuffer = new int[1024];
	private int[] DispX = new int[1024];
	private long Frequency, FixFrequency;
	private byte Flag, FixMode;
	private int result, Counter, i, BlockCounter, State, temp;
	private float Level;
	private final Handler handler = new Handler();
	// クラス変数、定数の宣言
	private final static int WC = LinearLayout.LayoutParams.WRAP_CONTENT;
	private static Button start, fixfreq;	
	private static TextView text, text0, text1, text2, text3, text4, text10, text11, text12;
	private static EditText editText1;
	private static MyView graph;
	private static Thread thread;
	// USB control commands    
	private static final int COMMAND_REQUEST = 0x31;
	private static final int COMMAND_EXTEND  = 0x32;

	/***********************************************************************/
    /******* 最初に実行する関数 画面のレイアウト作成 ******/
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE); 
        this.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);
        /*** レイアウト定義　*******/     
        LinearLayout layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.HORIZONTAL);
        setContentView(layout); 
        	// サブレイアウト
        	LinearLayout layout2 = new LinearLayout(this);
            layout2.setOrientation(LinearLayout.VERTICAL);
            layout2.setGravity(Gravity.CENTER); 
             	// 見出しテキスト表示             
    	        text1 = new TextView(this);
    	        text1.setLayoutParams(new LinearLayout.LayoutParams(230,WC));
    	        text1.setTextSize(30f);
    	        text1.setTextColor(Color.MAGENTA);
    	        text1.setText("周波数特性測定");
    	        layout2.addView(text1);
    	        
    	        // 開始ボタン作成
    	    	start = new Button(this);
    	    	start.setBackgroundColor(Color.YELLOW);
    	    	start.setTextColor(Color.BLACK);
    	    	start.setTextSize(25f);
    	    	start.setText("スイープ");
    	    	LinearLayout.LayoutParams params = new LinearLayout.LayoutParams(160, 50);
      	    	params.setMargins(0,10, 0,50);   	    	
    	    	start.setLayoutParams(params);
    	    	layout2.addView(start);

    	    	// 周波数設定エディタボックス生成
    	    	text10 = new TextView(this);
    	    	text10.setTextSize(20f);
      	        text10.setLayoutParams(new LinearLayout.LayoutParams(230,WC));
      	        text10.setText("　設定周波数(Hz)");
      	        layout2.addView(text10);
    	    	editText1 = new EditText(this);
    	    	editText1.setLayoutParams(new LinearLayout.LayoutParams(160, 60));
    	    	editText1.setText("1000", EditText.BufferType.NORMAL);
    	    	editText1.setTextSize(30f);
    	    	layout2.addView(editText1);

    	    	// 固定出力ボタン生成
    	    	params.setMargins(0, 10, 0, 10);
    	    	fixfreq = new Button(this);
    	    	fixfreq.setBackgroundColor(Color.BLUE);
     	    	fixfreq.setText("固定出力");
     	    	fixfreq.setTextSize(25f);
    	    	fixfreq.setLayoutParams(params);
    	    	layout2.addView(fixfreq);
    	    	
    	    	// 測定レベル表示テキストボックス生成
    	    	text11 = new TextView(this);
    	    	text11.setTextSize(20f);
      	        text11.setLayoutParams(new LinearLayout.LayoutParams(230,WC));
      	        text11.setText("　測定レベル(dB)");
      	        layout2.addView(text11);
    	    	text12 = new TextView(this);
    	    	text12.setTextSize(30f);
      	        text12.setLayoutParams(new LinearLayout.LayoutParams(80,40));
      	        text12.setText("　0.0");
      	        layout2.addView(text12); 	    	 	    	
    	    	
     	    	
    	    	// デバッグ用メッセージボックス生成
            	text = new TextView(this);
            	text.setGravity(Gravity.FILL_VERTICAL | Gravity.BOTTOM);
            	text.setTextSize(14f);
      	        text.setLayoutParams(new LinearLayout.LayoutParams(230,150));
    	        text.setText(" ");
    	        layout2.addView(text);
    	        
    	    	text0 = new TextView(this);
    	    	text0.setTextSize(14f);
      	        text0.setLayoutParams(new LinearLayout.LayoutParams(230,WC));
      	        text0.setText("デバッグメッセージNo1 ");
      	        layout2.addView(text0);
      	        
            	text2 = new TextView(this);
             	text2.setTextSize(14f);
      	        text2.setLayoutParams(new LinearLayout.LayoutParams(230,WC));
    	        text2.setText("デバッグメッセージ No2");
    	        layout2.addView(text2); 
      	        
    	        text3 = new TextView(this);
    	        text3.setTextSize(14f);
    	        text3.setLayoutParams(new LinearLayout.LayoutParams(230,WC));
    	        text3.setText("デバッグメッセージ No3");
    	        layout2.addView(text3); 
    	        
    	        text4 = new TextView(this);
    	        text4.setTextSize(14f);
    	        text4.setLayoutParams(new LinearLayout.LayoutParams(230,WC));
    	        text4.setText("デバッグメッセージ No4");
    	        layout2.addView(text4);
    	        layout.addView(layout2);
    	// グラフ表示領域指定
     	graph = new MyView(this);
        layout.addView(graph); 
        // スイッチイベント組み込み
        start.setOnClickListener((OnClickListener) new startScope());
        fixfreq.setOnClickListener((OnClickListener) new fixfreqScope());	 
        
        // USB組み込み
		mUsbManager = (UsbManager)getSystemService(Context.USB_SERVICE);
		
		// データバッファ初期化
    	BlockCounter = 0;		
		for(i=0; i<1024; i++){
			DataBuffer[i] = 0;
			DispX[i] = i;
		}
    }
    
    /****************************************************************************/
	/**** USBデバイスの検出と接続 ***/
	@Override    
	public void onResume() {   
		super.onResume();        
		Intent intent = getIntent();
 		String action = intent.getAction(); 
 		
		UsbDevice device = (UsbDevice)intent.getParcelableExtra(UsbManager.EXTRA_DEVICE); 
		// USBデバイスアタッチ検出
		if (UsbManager.ACTION_USB_DEVICE_ATTACHED.equals(action)) { 
			text0.setText("USBデバイスアタッチ検出");
			setDevice(device); 
		} else if (UsbManager.ACTION_USB_DEVICE_DETACHED.equals(action)) {      
			if (mDevice != null && mDevice.equals(device)) {          
				setDevice(null);
				mConnection.close();
				text0.setText("USBデバイス　デタッチ状態");
			}    
		}
	}  
	
	/**** USB終了時クローズ ****/
	@Override    
	public void onDestroy() {    
		super.onDestroy();
	}   
	
	/***** USBデバイスEnumeration ******/
	private void setDevice(UsbDevice device) { 
		// デバイスインターフェース検出
		if (device.getInterfaceCount() != 1) { 
			text2.setText("インターフェース発見できない");			
			return;  
		}        
		UsbInterface intf = device.getInterface(0);        
		// エンドポイントの検出       
		if (intf.getEndpointCount() < 1) { 
			text2.setText("エンドポイント検出できない");
			return;    
		} 
		text2.setText("検出エンドポイント数 = " + intf.getEndpointCount());		
		// OUTエンドポイントの確認        
		UsbEndpoint epout = intf.getEndpoint(0); 
		if (epout.getType() != UsbConstants.USB_ENDPOINT_XFER_BULK) { 
			text2.setText("OUTエンドポイントがバルクタイプでない");
			return;   
		}
		// INエンドポイントの確認
		UsbEndpoint epin = intf.getEndpoint(1);
		if (epin.getType() != UsbConstants.USB_ENDPOINT_XFER_BULK) { 
			text2.setText("INエンドポイントがバルクタイプでない");
			return;   
		}
		// デバイス定数代入
		mDevice = device;        
		mEndpointOut = epout;
		mEndpointIn = epin;
		// 接続許可確認
		if (mDevice != null) {       
			UsbDeviceConnection connection = mUsbManager.openDevice(mDevice);           
			if (connection != null && connection.claimInterface(intf, true)) {          
				mConnection = connection;
				text3.setTextColor(Color.GREEN);
				text3.setText("USBデバイス接続正常完了");				
				Flag = 1;								// スレッドループ用フラグ
				State = 0;								// イベント待ちステートへ
				BlockCounter = 0;						// バッファインデックスリセット
				thread = new Thread(this);         		// 計測表示スレッドセット      
				thread.start();         				// スレッド開始（永久継続)
			} else {         
				mConnection = null;						// USB接続できなかっったエラー
				text3.setTextColor(Color.RED);
				text3.setText("USBデバイス接続失敗");
			}    
		}
	} 
	
	/*******************************************************************************/
    /***** SW1イベントクラス *****/
    class startScope implements OnClickListener{
    	public void onClick(View v){
    		BlockCounter = 0;						// 格納ポインタリセット
    		Frequency = 10;							// スイープ開始周波数
    		State = 1;								// 初期ステート
    		FixMode = 0;							// 固定周波数モードリセット
    	}    		
    }
    
    /****  ボタンイベントクラス ***/
    class fixfreqScope implements OnClickListener{
    	public void onClick(View v){
    		// 設定周波数の取得
    		SpannableStringBuilder temb = (SpannableStringBuilder)editText1.getText();
    		FixFrequency = Long.parseLong(temb.toString());
    		FixMode = 1;							// 固定周波数モードにセット
     		State = 1;								// 初期ステート		
    	}    		
    }  
    	
	/**** コマンド送信サブメソッド *****/
	private void sendCommand(int control) { 
		synchronized (this) {                 
			if (mConnection != null) { 					// USB接続中か？         
				switch(control){
					case COMMAND_REQUEST:
						message[0] = COMMAND_REQUEST;
						break;
					case COMMAND_EXTEND:
						message[0] = COMMAND_EXTEND;
						break;
					default: break;
				}
				// エンドポイントでコマンド送信	常に64バイト送信				
				mConnection.bulkTransfer(mEndpointOut, message, 64, 0);
				// 出力確認メッセージ（デバッグ用)
				Counter++;
				handler.post(new Runnable(){
					public void run(){
						text4.setText("コマンド送信回数 = " + Counter); 			
					}
				});				
			}
		}
	}
	
	/******************************************************************************/	
	/**** USBデータ送受信スレッド 一定周期で繰り返し ***/
	@Override    
	public void run() { 
		while (Flag == 1) {
			// 計測要求コマンド送信
			switch(State){
				case 0:												// イベント待ちステート
					try{
						Thread.sleep(10);							// 10msecお休み
					}catch(InterruptedException e){ }
					break;
				case 1:
					sendCommand(COMMAND_REQUEST);					// 測定要求送信
					result = mConnection.bulkTransfer(mEndpointIn, buffer, 64, 0);
					if((result > 0)&&(buffer[0] == 'O')&&(buffer[1] == 'K')){
						State = 2;
						Frequency = 10;
						BlockCounter = 0;
					}
					/* 正常応答でなければデバイスが切り離されたとしてスレッド終了	*/	
					else{
						mConnection.close();
						Flag = 0;									// ループフラグクリア
						handler.post(new Runnable(){				// エラーメッセージ出力
							public void run(){
								text4.setTextColor(Color.RED);
								text4.setText("デバイスが切り離されました！！"); 			
							}
						});						
					}
					break;
				case 2:						// 測定要求
					if(FixMode == 1)								// 固定周波数モードか？
						Frequency = FixFrequency;					// 固定周波数に置き換え
					message[1] = (byte)Frequency;					// 周波数を送信バッファにセット
					message[2] = (byte)(Frequency >>> 8);			// バイト単位で4バイト
					message[3] = (byte)(Frequency >>> 16);
					message[4] = (byte)(Frequency >>> 24);
					sendCommand(COMMAND_EXTEND);					// コマンドとして送信実行	
					try{											// データ計測時間確保
						Thread.sleep(160);							// 0.16秒お休み
					}catch(InterruptedException e){ }
					// 折り返し計測結果データ受信　常に64バイト受信
					result = mConnection.bulkTransfer(mEndpointIn, buffer, 64, 0);
					// 正常受信なら受信データ処理実行
					if(result > 0){
						// データのバッファ格納 ByteからIntegerに変換
						temp = (buffer[1] & 0x7F) + buffer[2]*256;
						if((buffer[1] & 0x80) != 0)
							temp += 128;
						// レベルの実機補正と格納
						// 実機測定　0dB=428　-20dB=318　傾き106
						DataBuffer[BlockCounter] = 2*(temp - 428);			// バッファの保存（Y値）						
						Level = (float)((temp -428)/5.50);
						handler.post(new Runnable(){						// 測定レベルのテキスト表示
							public void run(){
								text12.setText(Float.toString(Level));									
							}
						});
						// X軸位置の計算とバッファ保存
						DispX[BlockCounter] = (int)((Math.log10(Frequency)-1)*1000/6);
						if(DispX[BlockCounter] > 1000){					// X軸が右端まで到達したか？
							BlockCounter = 0;							// 最初に戻す
							State = 0;									// 何もしない状態とする
						}
						else{
							/*　固定モードでないとき周波数更新 */
							if(FixMode == 0){
								Frequency = Frequency + (long)(Math.pow(10, (int)(Math.log10(Frequency))))/10;							
								BlockCounter++;
							}
							State = 3;									// グラフ表示ステートへ
						}
					}
					/* 正常受信できなければデバイスが切り離されたとしてスレッド終了	*/	
					else{
						mConnection.close();
						Flag = 0;										// ループフラグクリア
						handler.post(new Runnable(){					// メッセージ出力
							public void run(){
								text4.setTextColor(Color.RED);
								text4.setText("デバイスが切り離されました！！"); 			
							}
						});							
					}
					break;
				case 3:		// データ表示
					handler.post(new Runnable(){
						public void run(){
							// データグラフの再表示			
							graph.invalidate();		
						}
					});
					State = 2;										// 計測繰り返し
					break;			
				default:
					State = 0;										// イベント待ちステートへ
			}
		}
	}
	
	/*********************************************************************************/
	// グラフを表示するクラス
	class MyView extends View{
		// Viewの初期化とコンストラクタ設定
		public MyView(Context context){
			super(context);

		}
		// グラフ表示実行メソッド
		public void onDraw(Canvas canvas)
		{
			int i, j;
			int xaxis;
 		
	 		super.onDraw(canvas);
	 		//背景色の設定
	 		Paint set_paint = new Paint();
			canvas.drawColor(Color.BLACK); 		
			
			/** 座標の表示 青色で表示**/
			set_paint.setColor(Color.BLUE);
			set_paint.setStrokeWidth(1);
			// 縦軸の表示　10本
			for(i=0; i<7; i++){
				for(j=1; j<10; j++){
					xaxis = (int)(Math.log10(j*Math.pow(10,i))*1000/6);
					canvas.drawLine(35+xaxis, 10, 35+xaxis, 710, set_paint);
				}
			}
			// 横軸の表示　7本
			for(i=0; i<7; i++){
				canvas.drawLine(35, 10+i*100, 1035, 10+i*100, set_paint);
			}
			// Y軸の0dBライン白色で描画
			set_paint.setStrokeWidth(1);   			
			set_paint.setColor(Color.CYAN);
			canvas.drawLine(35, 210, 1035, 210, set_paint);
			set_paint.setColor(Color.WHITE);
			set_paint.setStrokeWidth(2);   		
			canvas.drawLine(35, 10, 35, 710, set_paint);
			canvas.drawLine(1035, 10, 1035, 710, set_paint);
			canvas.drawLine(35, 10, 1035, 10 ,set_paint);
			canvas.drawLine(35, 710, 1035, 710, set_paint);			
			// 軸目盛の表示			
			set_paint.setAntiAlias(true);
			set_paint.setTextSize(20f);					// 文字サイズ指定
			set_paint.setColor(Color.WHITE);			// 文字色指定
			// X座標目盛
			for(i=0; i<7; i++){
				switch(i){
					case 0:
						canvas.drawText("10", (int)(Math.log10(Math.pow(10, i))*1000/6)+21, 735, set_paint);   			
						break;
					case 1:
						canvas.drawText("100", (int)(Math.log10(Math.pow(10, i))*1000/6)+17, 735, set_paint);   			
						break;
					case 2:
						canvas.drawText("1k", (int)(Math.log10(Math.pow(10, i))*1000/6)+21, 735, set_paint);   			
						break;
					case 3:
						canvas.drawText("10k", (int)(Math.log10(Math.pow(10, i))*1000/6)+15, 735, set_paint);   			
						break;
					case 4:	
						canvas.drawText("100k", (int)(Math.log10(Math.pow(10, i))*1000/6)+13, 735, set_paint);   			
						break;
					case 5:	
						canvas.drawText("1M", (int)(Math.log10(Math.pow(10, i))*1000/6)+15, 735, set_paint);   			
						break;
					case 6:
						canvas.drawText("10M", (int)(Math.log10(Math.pow(10, i))*1000/6)+10, 735, set_paint);   			
						break;
					default:
						break;
				}
			}
 			// Y座標目盛
			for(i=-50; i<=20; i+=10){
				canvas.drawText(Integer.toString(i), 0, 218-i*10, set_paint);
			}
			set_paint.setColor(Color.GREEN);						// グラフY軸見出し色設定
			canvas.drawText("周波数(Hz)", 400, 740, set_paint); 	// 軸見出し指定		
			canvas.drawText("dB", 0, 250, set_paint); 				// Y軸の単位表示
			// 実際のグラフの表示
 			set_paint.setColor(Color.RED);       		
 			for(i=2; i<BlockCounter; i++){
 				canvas.drawLine(DispX[i-1]+35, 210-DataBuffer[i-1], DispX[i]+35, 210-DataBuffer[i], set_paint);
  			}
		}
	}
}
