/********************************************************************
*  Android$B$K$h$k<~GH?tFC@-B,Dj(B
*  PIC18F14K50 $B$r;HMQ$7!"(BUSB$BHFMQ%9%l!<%V$GF0:n(B
*  $B@589GH=PNO!'(BAD5932$B!!(BSPI$B@\B3(B
*  $B%m%0%"%s%W!'(BAD8310$B!!(BAN5$B$G%"%J%m%0F~NO(B
********************************************************************/
#include <USB/usb.h>
#include <USB/usb_function_generic.h>
#include <HardwareProfile.h>
#include <GenericTypeDefs.h>
#include <usb_config.h>

/** $B%3%s%U%#%.%e%l!<%7%g%s!!(B***********************/
#pragma config CPUDIV = NOCLKDIV ,USBDIV = OFF, PCLKEN = ON
#pragma config FOSC = HS, PLLEN = ON, HFOFST = OFF
#pragma config PWRTEN = ON, BOREN = OFF, MCLRE = ON, BORV = 27
#pragma config WDTEN = OFF, LVP = OFF, FCMEN = OFF, IESO = OFF
#pragma config CP0 = OFF, XINST = OFF, BBSIZ = OFF

/*** $B%9%F!<%HDj?tDj5A(B ***/
typedef enum
{
    TRIG	= 0x31,
	NEXT	= 0x32
}TYPE_CMD;
/******** USB$B4XO"%P%C%U%!!"JQ?tDj5A(B ****/
#pragma udata usbram2
BYTE INPacket[64];	// USB$BAw?.%P%C%U%!(B
BYTE OUTPacket[64];	// USB$B<u?.%P%C%U%!(B
#pragma udata
USB_HANDLE USBGenericOutHandle;
USB_HANDLE USBGenericInHandle;
/**** $BJQ?tDj5A!!(B***/
BYTE  counter;
BOOL  blinkStatusValid;
int i, j;
union{
	unsigned long Freq;
	unsigned int  iFreq[2];
	unsigned char cFreq[4];
}ddsFreq;
unsigned long oldFreq;

/** $B4X?t%W%m%H%?%$%T%s%0(B ****************************/
void YourHighPriorityISRCode();
void YourLowPriorityISRCode();
void USBDeviceTasks(void);
void BlinkUSBStatus(void);
void ProcessIO(void);
void spi_send(unsigned int data);
void setFreq(long freq);
void Delayms( unsigned int t);


/****** $B3d$j9~$_%Y%/%?Dj5A(B *************/
#pragma code REMAPPED_HIGH_INTERRUPT_VECTOR = 0x08
void Remapped_High_ISR (void)
{     _asm goto YourHighPriorityISRCode _endasm		}
#pragma code REMAPPED_LOW_INTERRUPT_VECTOR = 0x18
void Remapped_Low_ISR (void)
{     _asm goto YourLowPriorityISRCode _endasm	}

#pragma code
/***+*** $B3d$j9~$_=hM}4X?t(B *****************/
#pragma interrupt YourHighPriorityISRCode
void YourHighPriorityISRCode(){
        USBDeviceTasks();
}
#pragma interruptlow YourLowPriorityISRCode
void YourLowPriorityISRCode(){
}

#pragma code
/************ $B%a%$%s4X?t(B ********************/
void main(void)
{
    /* $BF~=PNO%]!<%H@_Dj(B  */
    ddsFSYN = 1;
    ddsCTRL = 1;
    ANSELH = 0x00;
    ANSEL  = 0x20;				// only AN5
    TRISA = 0xFF;				// OSC SI$B$N$_F~NO(B
    TRISB = 0x00;
    TRISC = 0x02;				// AN5 only
    // A/D$B%3%s%P!<%?=i4|@_Dj(B
    ADCON0 = 0x14;				// AD off Select AN5
    ADCON1 = 0x00;				// Analog Vss-Vdd
    ADCON2 = 0xBE;				// Right,20Tad,1/64
    /** DDS$B$N=i4|@_Dj!!(B**/
    ddsFreq.Freq = 1000;			// $B=i4|CM(B1kHz
    oldFreq = 0;
    spi_send(0x07FF);				// $B@)8f%3%^%s%IAw?.(B
    spi_send(0x1000);				// $B%$%s%/%j%a%s%H?t$J$7(B
    spi_send(0x2000);				// $B&$(Bf$B$J$7(B
    spi_send(0x3000);				// $B&$(Bf$B$J$7(B
    spi_send(0x4000);				// $B%$%s%?!<%P%k$J$7(B
    setFreq(1000);				// $B=i4|CM(B1kHz
    /* USB$B=i4|2=$H(BAP$B%9%?!<%H(B */
    USBDeviceInit();				// USB$B=i4|2=(B
    USBGenericInHandle = 0;
    USBGenericOutHandle = 0;
    blinkStatusValid = TRUE;			// USB$BL\0u(BLED$BM-8z2=(B
    /** USB$B%"%?%C%A5v2D$H3d$j9~$_5v2D(B */
    USBDeviceAttach();

    /*********** $B%a%$%s%k!<%W(B ***************/
    while(1)
    {
        /** USB$BL\0u(BLED$BE@LG(B **/
        if(blinkStatusValid)
            BlinkUSBStatus();			// LED$BE@LG<B9T(B
        /** USB$B@\B3Cf$J$iAw<u?.<B9T(B **/
        if((USBDeviceState >= CONFIGURED_STATE)&&(USBSuspendControl!=1))
            ProcessIO();			// $B%f!<%6!<%"%W%j<B9T(B
    }
}

/***************************************************
 * $B%f!<%6!<%"%W%j!"F~=PNO=hM}4X?t(B
 * USB$B$+$i$N%3%^%s%I$K$h$j5!G=<B9T(B
 * $B3+;O%3%^%s%I$HB,Dj%3%^%s%I$N(B2$B<oN`$N$_(B
 ***************************************************/
void ProcessIO(void)
{
    /***** $B%G!<%?<u?.=hM}(B ******/
    if(!USBHandleBusy(USBGenericOutHandle))                 // $B<u?.40N;$+!)(B
    {
        blinkStatusValid = FALSE;                           // USB$BL\0u(BLED$BCf;_(B
        counter = 0;                                        // $BAw?.%P%$%H?t%j%;%C%H(B

        /******** $B<u?.%3%^%s%I$4$H$N=hM}(B ********/
        switch(OUTPacket[0])                                // $B%3%^%s%I%3!<%I%A%'%C%/(B
        {
            unsigned int temp;
            /** $B%G!<%?7WB,3+;O%H%j%,(B ***/
            case TRIG:
                INPacket[0] = 'O';
                INPacket[1] = 'K';
                counter = 2;
                break;
            /** $B<~GH?t@_Dj$H%l%Y%kB,DjCMJVAw(B */
            case NEXT:
//                mLED_2_Toggle();                            // $BL\0u(BLED$BE@LG(B
                /** $B<~GH?t@_DjCM<hF@$H@_Dj@)8f(B **/
                for(i=0; i<4; i++)
                    ddsFreq.cFreq[i] = OUTPacket[i+1];      // $B%P%$%H$+$i?tCM$XJQ49(B
                if(ddsFreq.Freq != oldFreq)                 // $BF1$8<~GH?t$J$i2?$b$7$J$$(B
                    setFreq(ddsFreq.Freq);                  // $B0[$J$k<~GH?t$J$i@_Dj=PNO<B9T(B
                oldFreq = ddsFreq.Freq;                     // $B5l<~GH?t%G!<%?$r99?7(B
                /* $B7WB,CM0BDj2=BT$A!!(B**/
                Delayms(100);                               // $BHoB,DjAuCV$N=PNO0BDjBT$A(B
                /* $B%l%Y%k7WB,%G!<%?JVAw(B */
                temp = 0;
                for(i=0; i<10; i++){                        // 10$B2s$NJ?6Q(B
                    ADCON0 = 0x15;                          // $B%A%c%M%k(B5$BA*Br(B ADON
                    ADCON0bits.GO = 1;                      // $BJQ493+;O(B
                    while(ADCON0bits.GO);                   // $BJQ49=*N;BT$A(B
                    temp = temp + ADRESH*256 + ADRESL;      // CH1$BB,Dj(B
                    Delayms(2);                             // 2msec$B4V3V$G%5%s%W%j%s%0(B
                }
                INPacket[0] = 0x32;                         // $B1~Ez%G!<%?(B
                INPacket[1] = (temp/10) % 256;              // $BAw?.%P%C%U%!$K2<0L%;%C%H(B
                INPacket[2] = (temp/10) / 256;              // $BAw?.%P%C%U%!$K>e0L%;%C%H(B
                counter = 3;                                // $BAw?.%G!<%??t(B
                break;
            /*** $BITL@(B ****/
            default:
                Nop();
                break;
        }
        /**** USB$BAw<u?.<B9T(B  *****/
        if(counter != 0)                                    // $BAw?.%G!<%?$"$j$+!)(B
        {
            if(!USBHandleBusy(USBGenericInHandle))          // $B%S%8!<%A%'%C%/(B
            {	/* $BAw?.<B9T!!(B*/
                USBGenericInHandle = USBGenWrite(USBGEN_EP_NUM,(BYTE*)&INPacket,64);
            }
        }
        /* $B<!$N<u?.<B9T(B */
        USBGenericOutHandle = USBGenRead(USBGEN_EP_NUM,(BYTE*)&OUTPacket,64);
    }
}

/****************************************************************
* AD5932 DDS$B@_Dj@)8f4X?t(B
*$B!!!!%"%I%l%9!!5!G=(B
*$B!!!!(B0000$B!!!!%3%s%H%m!<%k%3%^%s%I(B
*$B!!!!(B0001$B!!!!%$%s%/%j%a%s%H?t(B
*$B!!!!(B0010$B!!!!&$(Bf$B2<0L(B12$B%S%C%H(B
*$B!!!!(B0011$B!!!!&$(Bf$B>e0L(B12$B%S%C%H(B
*$B!!!!(B0100$B!!!!%$%s%/%j%a%s%H%$%s%?!<%P%k(B
*$B!!!!(B1100$B!!!!3+;O<~GH?t2<0L(B12$B%S%C%H(B
*$B!!!!(B1101$B!!!!3+;O<~GH?t>e0L(B12$B%S%C%H(B
*$B!!%3%s%H%m!<%k%3%^%s%I(B   0000 0111 1111 1111
*$B!!!!(BD11$B!!!!!!(B0$B$GFHN)!!(B1$B$GO"B3(B
*$B!!!!(BD10$B!!!!!!(B1$B$G(BDAC$B%$%M!<%V%k(B
*$B!!!!(BD9$B!!!!!!(B 1$B$G@589GH!!(B0$B$G;03QGH(B
*$B!!!!(BD8$B!!!!!!(B 1$B$G(BMSBOUT$B%$%M!<%V%k(B
*$B!!!!(BD7,D6$B!!!!M=Hw!!(B1$B$H$9$k(B
*$B!!!!(BD5$B!!!!!!(B 1$B$N$H$-(BCTRL$B%T%s$G%$%s%/%j%a%s%H(B
*$B!!!!(BD4 $B!!!!!!M=Hw!!(B1$B$H$9$k(B
*$B!!!!(BD3$B!!!!!!(B SYNCOUT$B=PNO>r7o(B1$B$G%9%-%c%sA4BN!"(B0$B$G%$%s%/%j%a%s%H$4$H(B
*$B!!!!(BD2$B!!!!!!(B 1$B$G(BSYNCOUT$B%$%M!<%V%k(B
*$B!!!!(BD1,D0$B!!!!M=Hw!!(B1$B$K%;%C%H(B
*  $B<~GH?t@_DjCM(B
*$B!!!!!!(B1$B%S%C%HEv$?$j(B2.980232Hz@50MHz
*$B!!!!!!(B1Hz=FFFFFF/(50MHz) = 0.335544$B%S%C%H(B
******************************************************************/
void setFreq(long freq){
    float temp;
    union{
        unsigned long para;
        unsigned int ipara[2];
    }DDSpara;

    /* $B<~GH?t@_DjCM$KJQ49(B */
    temp = (0.33555 * (float)freq);			// $B<~GH?t$KJQ49(B
    DDSpara.para = (long)temp << 4;			// $B>e0L(B12$B%S%C%H!"2<0L(B12$B%S%C%H@_DjCM$KJQ49(B
    /* DDS$B@)8f<B9T(B */
    ddsCTRL = 1;					// CTRL = 0
    spi_send(0x07FF);					// $B@)8f%3%^%s%IAw?.(B
    spi_send(0xC000 | ((DDSpara.ipara[0]>>4) & 0x0FFF));// $B<~GH?t2<0L(B12$B%S%C%HAw?.(B
    spi_send(0xD000 | (DDSpara.ipara[1] & 0x0FFF));	// $B<~GH?t>e0L(B12$B%S%C%HAw?.(B
    ddsCTRL = 0;
    ddsCTRL = 1;					// CTRL=1 $B<~GH?t=PNO3+;O(B
}

/**************************************************
* SPI $B$G(B16$B%S%C%HAw?.4X?t(B
**************************************************/
void spi_send(unsigned int data){
    unsigned int mask;

    ddsFSYN = 0;			// CS High
    ddsSCLK = 1;			// SCK high
    mask = 0x8000;			// $B%S%C%H%^%9%/=i4|CM%;%C%H(B
    for(i=0; i<16; i++){		// 16$B%S%C%H7+$jJV$7(B
        if((data & mask) !=0)		// $B%S%C%H%A%'%C%/(B
            ddsSDAT = 1;		// 1$B$N>l9g(B
        else
            ddsSDAT = 0;		// 0$B$N>l9g(B
        Nop();
        ddsSCLK = 0;			// SCK Low
        Nop();
        Nop();				// $B%Q%k%9I}3NJ](B
        ddsSCLK = 1;			// SCK High$B$KLa$9(B
        mask = mask >>1;		// $B%S%C%H%^%9%/0\F0(B
    }
    ddsFSYN = 1;			// CS High
}
/***********************************************
* $B%?%$%^#1$K$h$k(B1msec$BC10L$NCY1d4X?t(B
***********************************************/
void Delayms( unsigned int t)
{
    T1CON = 0x8000;     		// enable tmr1, Tcy, 1:1
    while (t--) {
        TMR1H = 0;
        TMR1L = 0;
        while ((TMR1H == 0x2E)&&(TMR1L = 0xE0));// 1msec$BBT$A(B
    }
}

/****************************************************/
/****************************************************
 * USB$B>uBVI=<(MQ(BLED$B%V%j%s%/=hM}4X?t(B
 *  USB$B%"%?%C%A!'9bB.%V%j%s%/(B
 *  USB$B@\B340N;!'DcB.%V%j%s%/(B
 ***************************************************/
void BlinkUSBStatus(void)
{
    static WORD led_count=0;

    if(led_count == 0)led_count = 10000U;
    led_count--;
    #define mLED_Both_Off()         {mLED_1_Off();mLED_2_Off();}
    #define mLED_Both_On()          {mLED_1_On();mLED_2_On();}
    #define mLED_Only_1_On()        {mLED_1_On();mLED_2_Off();}
    #define mLED_Only_2_On()        {mLED_1_Off();mLED_2_On();}
    if(USBSuspendControl == 1)
    {
        if(led_count==0)
        {
            mLED_1_Toggle();
            if(mGetLED_1())
            {	mLED_2_On();	}
            else
            {	mLED_2_Off();	}
        }
    }
    else
    {
        if(USBDeviceState == DETACHED_STATE)
        {	mLED_Both_Off();	}
        else if(USBDeviceState == ATTACHED_STATE)
        {	mLED_Both_On();		}
        else if(USBDeviceState == POWERED_STATE)
        {	mLED_Only_1_On();	}
        else if(USBDeviceState == DEFAULT_STATE)
        {	mLED_Only_2_On();	}
        else if(USBDeviceState == ADDRESS_STATE)
        {
            if(led_count == 0){
                mLED_1_Toggle();
                mLED_2_Off();
            }
        }
        else if(USBDeviceState == CONFIGURED_STATE)	{
            if(led_count==0){
                mLED_1_Toggle();
                if(mGetLED_1())
                {   mLED_2_Off();	}
                else
                {   mLED_2_On();	}
            }
        }
    }
}
/******************************************************************
************** USB Callback Functions *****************************
*******************************************************************/
/******************************************************************
 * Function:        void USBCBSuspend(void)
 ******************************************************************/
void USBCBSuspend(void)
{
}
/*******************************************************************
 * Function:        void USBCBWakeFromSuspend(void)
 *******************************************************************/
void USBCBWakeFromSuspend(void)
{
}
/********************************************************************
 * Function:        void USBCB_SOF_Handler(void)
 *******************************************************************/
void USBCB_SOF_Handler(void)
{
}
/*******************************************************************
 * Function:        void USBCBErrorHandler(void)
 *******************************************************************/
void USBCBErrorHandler(void)
{
}
/*******************************************************************
 * Function:        void USBCBCheckOtherReq(void)
 *******************************************************************/
void USBCBCheckOtherReq(void)
{
}//end
/*******************************************************************
 * Function:        void USBCBStdSetDscHandler(void)
 *******************************************************************/
void USBCBStdSetDscHandler(void)
{
}//end
/*******************************************************************
 * Function:        void USBCBInitEP(void)
 *******************************************************************/
void USBCBInitEP(void)
{
    USBEnableEndpoint(USBGEN_EP_NUM,USB_OUT_ENABLED|USB_IN_ENABLED|USB_HANDSHAKE_ENABLED|USB_DISALLOW_SETUP);
    USBGenericOutHandle = USBGenRead(USBGEN_EP_NUM,(BYTE*)&OUTPacket,USBGEN_EP_SIZE);
}
/*******************************************************************
 * Function:        void USBCBSendResume(void)
 ******************************************************************/
void USBCBSendResume(void)
{
    static WORD delay_count;

    if(USBGetRemoteWakeupStatus() == TRUE)
    {
        //Verify that the USB bus is in fact suspended, before we send
        //remote wakeup signalling.
        if(USBIsBusSuspended() == TRUE)
        {
            USBMaskInterrupts();

            //Clock switch to settings consistent with normal USB operation.
            USBCBWakeFromSuspend();
            USBSuspendControl = 0;
            USBBusIsSuspended = FALSE;  //So we don't execute this code again,

            delay_count = 3600U;
            do
            {
                delay_count--;
            }while(delay_count);

            //Now drive the resume K-state signalling onto the USB bus.
            USBResumeControl = 1;       // Start RESUME signaling
            delay_count = 1800U;        // Set RESUME line for 1-13 ms
            do
            {
                delay_count--;
            }while(delay_count);
            USBResumeControl = 0;       //Finished driving resume signalling

            USBUnmaskInterrupts();
        }
    }
}
/*******************************************************************
 * Function:        BOOL USER_USB_CALLBACK_EVENT_HANDLER(
 *******************************************************************/
BOOL USER_USB_CALLBACK_EVENT_HANDLER(USB_EVENT event, void *pdata, WORD size)
{
    switch(event)
    {
        case EVENT_TRANSFER:
            break;
        case EVENT_SOF:
            USBCB_SOF_Handler();
            break;
        case EVENT_SUSPEND:
            USBCBSuspend();
            break;
        case EVENT_RESUME:
            USBCBWakeFromSuspend();
            break;
        case EVENT_CONFIGURED:
            USBCBInitEP();
            break;
        case EVENT_SET_DESCRIPTOR:
            USBCBStdSetDscHandler();
            break;
        case EVENT_EP0_REQUEST:
            USBCBCheckOtherReq();
            break;
        case EVENT_BUS_ERROR:
            USBCBErrorHandler();
            break;
        case EVENT_TRANSFER_TERMINATED:

            break;
        default:
            break;
    }
    return TRUE;
}
